package com.example.servlet

import javax.servlet.http._
import javax.servlet._

import net.liftweb.util._
import net.liftweb.common._
import net.liftweb.http._
import net.liftweb.http.provider._
import net.liftweb.http.provider.servlet._
import net.liftweb.http.S._

class HelloWorldServlet extends HttpServlet {
   override def doGet(req: HttpServletRequest, res: HttpServletResponse): Unit = {
     val session = req.getSession
     val out = res.getWriter
     // session id
     out.println("[HttpSession.getId] " + session.getId)
     // not in scope
     out.println("[session scope? (should be false)] " + S.inStatefulScope_?)
     
     // try to get lift session
     val my_lift_session: LiftSession = SessionMaster.getSession(session.getId, Empty) openOr {
       val lowSession = new HTTPServletSession(session)
        val ret = LiftSession(lowSession, req.getContextPath())
        SessionMaster.addSession(ret)
       ret
     }
     // initialize with the lift session
     S.initIfUninitted(my_lift_session) 
     {
        // should be the same session id
        S.session.map(s => out.println("[S.session.uniqueId] " + s.uniqueId))
        // now we should be in session scope
        out.println("[session scope? (should be true)] " + S.inStatefulScope_?)
        
        // check if the user is logged in
        out.println("[logged in?] " + com.example.model.User.loggedIn_?)
        if (!com.example.model.User.loggedIn_?) {
           // if not logged in, log the user in within this session
           out.println("logging in")
           com.example.model.User.logUserIdIn("1")
           // check if the user is logged in now
           out.println("[now logged in?] " + com.example.model.User.loggedIn_?)
        }
     }
     out.println("Hello, world!")
     out.close
   }
}
